Index: /code/branches/menu/data/gui/layouts/DecisionPopup.layout
===================================================================
--- /code/branches/menu/data/gui/layouts/DecisionPopup.layout	(revision 6145)
+++ /code/branches/menu/data/gui/layouts/DecisionPopup.layout	(revision 6145)
@@ -0,0 +1,40 @@
+<?xml version="1.0" encoding="UTF-8"?>
+
+<GUILayout >
+    <Window Type="DefaultWindow" Name="orxonox/DecisionPopup_RootWindow" >
+        <Property Name="InheritsAlpha" Value="False" />
+        <Property Name="UnifiedMaxSize" Value="{{1,0},{1,0}}" />
+        <Property Name="UnifiedAreaRect" Value="{{0,0},{0,0},{1,0},{1,0}}" />
+        <Window Type="TaharezLook/StaticImage" Name="orxonox/DecisionPopup_Background" >
+            <Property Name="UnifiedMaxSize" Value="{{1,0},{1,0}}" />
+            <Property Name="UnifiedAreaRect" Value="{{0,0},{0,0},{1,0},{1,0}}" />
+            <Property Name="Alpha" Value="0.5" />
+            <Window Type="TaharezLook/Button" Name="orxonox/DecisionPopup_button_yes" >
+                <Property Name="Font" Value="BlueHighway-12" />
+                <Property Name="Text" Value="Yes" />
+                <Property Name="Alpha" Value="0.7" />
+                <Property Name="InheritsAlpha" Value="False" /> 
+                <Property Name="UnifiedMaxSize" Value="{{1,0},{1,0}}" />
+                <Property Name="UnifiedAreaRect" Value="{{0.3,0},{0.55,0},{0.45,0},{0.6,0}}" />
+                <Event Name="Clicked" Function="DecisionPopup.button_yes"/>
+            </Window>
+            <Window Type="TaharezLook/Button" Name="orxonox/DecisionPopup_button_no" >
+                <Property Name="Font" Value="BlueHighway-12" />
+                <Property Name="Text" Value="No" />
+                <Property Name="Alpha" Value="0.8" />
+                <Property Name="InheritsAlpha" Value="False" /> 
+                <Property Name="UnifiedMaxSize" Value="{{1,0},{1,0}}" />
+                <Property Name="UnifiedAreaRect" Value="{{0.55,0},{0.55,0},{0.7,0},{0.6,0}}" />
+                <Event Name="Clicked" Function="DecisionPopup.button_no"/>
+            </Window>
+            <Window Type="TaharezLook/StaticText" Name="orxonox/DecisionPopup_text" >
+                <Property Name="Text" Value="Template text" />
+                <Property Name="HorzFormatting" Value="WordWrapCentred" />
+                <Property Name="UnifiedMaxSize" Value="{{1,0},{1,0}}" />
+                <Property Name="UnifiedAreaRect" Value="{{0.2,0},{0.4,0},{0.8,0},{0.5,0}}" />
+                <Property Name="InheritsAlpha" Value="False" /> 
+                <Property Name="Alpha" Value="0.8" />
+            </Window>
+        </Window>
+    </Window>
+</GUILayout>
Index: /code/branches/menu/data/gui/layouts/MainMenuBackground.layout
===================================================================
--- /code/branches/menu/data/gui/layouts/MainMenuBackground.layout	(revision 6145)
+++ /code/branches/menu/data/gui/layouts/MainMenuBackground.layout	(revision 6145)
@@ -0,0 +1,10 @@
+<?xml version="1.0" ?>
+<GUILayout>
+    <Window Type="TaharezLook/StaticImage" Name="orxonox/Background">
+    <Property Name="UnifiedSize" Value="{{1.0,0},{1.0,0}}"/>
+    <Property Name="Image" Value="set:MainMenuBackground image:Background"/>
+    <Property Name="FrameEnabled" Value="set:true"/>
+    <Property Name="BackgroundEnabled" Value="set:false"/>
+    <Property Name="InheritsAlpha" Value="False" />
+    </Window>
+</GUILayout>
Index: /code/branches/menu/data/gui/scripts/DecisionPopup.lua
===================================================================
--- /code/branches/menu/data/gui/scripts/DecisionPopup.lua	(revision 6145)
+++ /code/branches/menu/data/gui/scripts/DecisionPopup.lua	(revision 6145)
@@ -0,0 +1,41 @@
+-- DecisionPopup.lua
+
+BasicGUI = require("BasicGUI")
+local P = BasicGUI:new() --inherit everything from the gui package
+if _REQUIREDNAME == nil then
+    DecisionPopup = P
+else
+    _G[_REQUIREDNAME] = P
+end
+
+P.filename = "DecisionPopup"
+P.layoutString = "DecisionPopup.layout"
+
+function P:init()
+end
+
+function P.setCallback(functionPtr)
+    P.functionPtr = functionPtr
+end
+
+function P.setText( text )
+    winMgr:getWindow("orxonox/DecisionPopup_text"):setText( text )
+end
+
+-- events for ingamemenu
+function P.button_yes(e)
+    if P.functionPtr ~= nil then
+        P.functionPtr(true)
+    end
+    orxonox.CommandExecutor:execute("hideGUI DecisionPopup")
+end
+
+function P.button_no(e)
+    if P.functionPtr ~= nil then
+        P.functionPtr(false)
+    end
+    orxonox.CommandExecutor:execute("hideGUI DecisionPopup")
+end
+
+return P
+
Index: /code/branches/menu/data/gui/scripts/GUITools.lua
===================================================================
--- /code/branches/menu/data/gui/scripts/GUITools.lua	(revision 6145)
+++ /code/branches/menu/data/gui/scripts/GUITools.lua	(revision 6145)
@@ -0,0 +1,6 @@
+function openDecisionPopup( text, callbackPtr )
+    orxonox.CommandExecutor:execute("showGUI DecisionPopup false true")
+--     showGUI("DecisionPopup", false, true)
+    DecisionPopup.setCallback(InGameMenu.callback)
+    DecisionPopup.setText(text)
+end