Index: /trunk/src/lib/collision_detection/cd_engine.cc
===================================================================
--- /trunk/src/lib/collision_detection/cd_engine.cc	(revision 6150)
+++ /trunk/src/lib/collision_detection/cd_engine.cc	(revision 6151)
@@ -142,5 +142,5 @@
   if( likely( this->terrain != NULL))
   {
-    Quadtree* q = this->terrain->ssp->getQuadtree();
+    Quadtree* q = dynamic_cast<Terrain*>(this->terrain)->ssp->getQuadtree();
 
 //    QuadtreeNode* n = q->getQuadtreeFromPosition(this->player->getAbsCoor());
Index: /trunk/src/story_entities/world.cc
===================================================================
--- /trunk/src/story_entities/world.cc	(revision 6150)
+++ /trunk/src/story_entities/world.cc	(revision 6151)
@@ -28,4 +28,5 @@
 #include "camera.h"
 #include "environment.h"
+#include "terrain.h"
 
 #include "test_entity.h"
@@ -405,6 +406,5 @@
 ErrorMessage World::start()
 {
-  this->bQuitOrxonox = false;
-  this->bQuitCurrentGame = false;
+  this->bQuitWorld = false;
   this->mainLoop();
 }
@@ -418,5 +418,5 @@
 {
   PRINTF(3)("World::stop() - got stop signal\n");
-  this->bQuitCurrentGame = true;
+  this->bQuitWorld= true;
 }
 
@@ -669,5 +669,5 @@
   PRINTF(3)("World::mainLoop() - Entering main loop\n");
 
-  while( !this->bQuitOrxonox && !this->bQuitCurrentGame) /* @todo implement pause */
+  while(!this->bQuitWorld) /* @todo implement pause */
   {
     ++this->cycle;
@@ -676,5 +676,5 @@
       // Process input
     this->handleInput ();
-    if( this->bQuitCurrentGame || this->bQuitOrxonox)
+    if( this->bQuitWorld)
       break;
       // Process time
Index: /trunk/src/story_entities/world.h
===================================================================
--- /trunk/src/story_entities/world.h	(revision 6150)
+++ /trunk/src/story_entities/world.h	(revision 6151)
@@ -7,10 +7,7 @@
 #define _WORLD_H
 
-#include "stdincl.h"
-#include "comincl.h"
+#include "sdlincl.h"
 #include "story_entity.h"
-#include "p_node.h"
 #include "object_manager.h"
-
 
 class WorldEntity;
@@ -52,7 +49,4 @@
   virtual void releaseLoadScreen();
 
-  /* command node functions */
-  bool command (Command* cmd);
-
   /* interface to world */
   void spawn (WorldEntity* entity);
@@ -84,7 +78,12 @@
     char* path;                         //!< The file from which this world is loaded
 
-    bool   showPNodes;                  //!< if the PNodes should be visible.
-    bool   showBV;                      //!< if the Bounding Volumes should be visible.
+    // FLAGS //
+    bool bQuitWorld;                    //!< quit only the current game and return to menu
+    bool bPause;                        //!< pause mode
 
+    bool showPNodes;                    //!< if the PNodes should be visible.
+    bool showBV;                        //!< if the Bounding Volumes should be visible.
+
+    // TIMING //
     Uint32 lastFrame;                   //!< last time of frame
     Uint32 cycle;                       //!< The cycle we are in (starts with 0 and rises with every frame)
@@ -93,21 +92,19 @@
     float speed;                        //!< how fast the game flows
     double gameTime;                    //!< this is where the game time is saved
-    bool bQuitOrxonox;                  //!< quit this application
-    bool bQuitCurrentGame;              //!< quit only the current game and return to menu
-    bool bPause;                        //!< pause mode
 
-    ObjectManager      objectManager;   //!< The ObjectManager of this World.
+    // INTERNAL ENGINES
+    ObjectManager objectManager;        //!< The ObjectManager of this World.
+    Shell*     shell;
+    OggPlayer* music;
 
     GLMenuImageScreen* glmis;           //!< The Level-Loader Display
 
-    Shell*     shell;
-    OggPlayer* music;
 
-  // IMPORTANT WORLD-ENTITIES
+    // IMPORTANT ENTITIES
     Camera* localCamera;                //!< The current Camera
+    Player* localPlayer;                //!< The Player, you fly through the level.
+
     WorldEntity* sky;                   //!< The Environmental Heaven of orxonox @todo insert this to environment insted
     Terrain* terrain;                   //!< The Terrain of the World.
-
-    Player* localPlayer;                //!< The Player, you fly through the level.
 };
 
Index: /trunk/src/util/loading/game_loader.cc
===================================================================
--- /trunk/src/util/loading/game_loader.cc	(revision 6150)
+++ /trunk/src/util/loading/game_loader.cc	(revision 6151)
@@ -151,5 +151,4 @@
     case DEBUG_CAMPAIGN_0:
       {
-        // FIXME
 /*        Campaign* debugCampaign = new Campaign();
 