Index: branches/christmas_branche/src/lib/graphics/importer/md2Model.cc
===================================================================
--- branches/christmas_branche/src/lib/graphics/importer/md2Model.cc	(revision 6171)
+++ branches/christmas_branche/src/lib/graphics/importer/md2Model.cc	(revision 6172)
@@ -160,7 +160,5 @@
     this->animate();
 
-  static sVec3D verticesList[MD2_MAX_VERTICES]; /* performance: created only once in a lifetime */
-  this->processLighting();
-  this->interpolate(verticesList);
+   this->renderFrame();
 }
 
@@ -171,9 +169,12 @@
  * FIXME
  */
-void MD2Model::draw() const
-{
-//   glPushMatrix();
-
-  this->renderFrame();
+void MD2Model::draw()
+{
+
+
+
+  //   glPushMatrix();
+
+  //this->renderFrame();
 
 //   glPopMatrix();
@@ -184,5 +185,5 @@
   \brief this is an internal function to render this special frame selected by animate()
 */
-void MD2Model::renderFrame() const
+void MD2Model::renderFrame()
 {
   static sVec3D verticesList[MD2_MAX_VERTICES]; /* performance: created only once in a lifetime */
@@ -195,4 +196,6 @@
   glCullFace(GL_BACK);
 
+  this->processLighting();
+  this->interpolate(verticesList);
 
   this->data->material->select();
Index: branches/christmas_branche/src/lib/graphics/importer/md2Model.h
===================================================================
--- branches/christmas_branche/src/lib/graphics/importer/md2Model.h	(revision 6171)
+++ branches/christmas_branche/src/lib/graphics/importer/md2Model.h	(revision 6172)
@@ -143,5 +143,5 @@
   virtual ~MD2Model();
 
-  virtual void draw() const;
+  virtual void draw();
 
   void setAnim(int type);
@@ -160,5 +160,5 @@
   void processLighting();
   void interpolate(sVec3D* verticesList);
-  void renderFrame() const;
+  void renderFrame();
 
 
Index: branches/christmas_branche/src/world_entities/creatures/md2_creature.cc
===================================================================
--- branches/christmas_branche/src/world_entities/creatures/md2_creature.cc	(revision 6171)
+++ branches/christmas_branche/src/world_entities/creatures/md2_creature.cc	(revision 6172)
@@ -113,5 +113,5 @@
   PRINTF(4)("SPACESHIP INIT\n");
 
-//   EventHandler::getInstance()->grabEvents(true);
+  EventHandler::getInstance()->grabEvents(true);
 
   bUp = bDown = bLeft = bRight = bAscend = bDescend = bRollL = bRollR = false;
@@ -253,5 +253,7 @@
 
   if( likely(this->models[0] != NULL))
-    ((MD2Model*)this->models[0])->tick(time);
+     ((MD2Model*)this->models[0])->tick(time);
+
+
 
 
Index: branches/christmas_branche/src/world_entities/space_ships/space_ship.cc
===================================================================
--- branches/christmas_branche/src/world_entities/space_ships/space_ship.cc	(revision 6171)
+++ branches/christmas_branche/src/world_entities/space_ships/space_ship.cc	(revision 6172)
@@ -112,5 +112,5 @@
   PRINTF(4)("SPACESHIP INIT\n");
 
-  EventHandler::getInstance()->grabEvents(true);
+//   EventHandler::getInstance()->grabEvents(true);
 
   bUp = bDown = bLeft = bRight = bAscend = bDescend = bRollL = bRollR = false;
Index: branches/christmas_branche/src/world_entities/world_entity.cc
===================================================================
--- branches/christmas_branche/src/world_entities/world_entity.cc	(revision 6171)
+++ branches/christmas_branche/src/world_entities/world_entity.cc	(revision 6172)
@@ -105,42 +105,43 @@
   if (fileName != NULL)
   {
-    // search for the special character # in the LoadParam
+   // search for the special character # in the LoadParam
     if (strchr(fileName, '#') != NULL)
+    {
+      PRINTF(4)("Found # in %s... searching for LOD's\n", fileName);
+      char* lodFile = new char[strlen(fileName)+1];
+      strcpy(lodFile, fileName);
+      char* depth = strchr(lodFile, '#');
+      for (unsigned int i = 0; i < 5; i++)
       {
-        PRINTF(4)("Found # in %s... searching for LOD's\n", fileName);
-        char* lodFile = new char[strlen(fileName)+1];
-        strcpy(lodFile, fileName);
-        char* depth = strchr(lodFile, '#');
-        for (unsigned int i = 0; i < 5; i++)
-          {
-            *depth = 48+(int)i;
-            printf("-------%s\n", lodFile);
-            if (ResourceManager::isInDataDir(lodFile))
-              this->loadModel(lodFile, scaling, i);
-          }
-          this->supportsLOD = true;
-        return;
+        *depth = 48+(int)i;
+        printf("-------%s\n", lodFile);
+        if (ResourceManager::isInDataDir(lodFile))
+          this->loadModel(lodFile, scaling, i);
       }
-
-      if( strchr(fileName, '.obj') != NULL)
-      {
-        PRINTF(4)("fetching OBJ file: %s\n", fileName);
-        if (scaling == 1.0)
-          this->setModel((Model*)ResourceManager::getInstance()->load(fileName, OBJ, RP_CAMPAIGN), modelNumber);
-        else
-          this->setModel((Model*)ResourceManager::getInstance()->load(fileName, OBJ, RP_CAMPAIGN, &scaling), modelNumber);
-
-        if( modelNumber == 0)
-          this->buildObbTree(4);
-      }
-      else if( strchr(fileName, '.md2') != NULL)
-      {
-        PRINTF(4)("fetching MD2 file: %s\n", fileName);
+      this->supportsLOD = true;
+      return;
+    }
+
+    if(strstr(fileName, ".obj"))
+    {
+      PRINTF(4)("fetching OBJ file: %s\n", fileName);
+      if (scaling == 1.0)
+        this->setModel((Model*)ResourceManager::getInstance()->load(fileName, OBJ, RP_CAMPAIGN), modelNumber);
+      else
+        this->setModel((Model*)ResourceManager::getInstance()->load(fileName, OBJ, RP_CAMPAIGN, &scaling), modelNumber);
+
+      if( modelNumber == 0)
+        this->buildObbTree(4);
+    }
+    else if(strstr(fileName, ".md2"))
+    {
+      PRINTF(0)("fetching MD2 file: %s\n", fileName);
 //         MD2Model* m = (MD2Model*)ResourceManager::getInstance()->load(fileName, MD2, RP_CAMPAIGN);
-        MD2Model* m = new MD2Model(fileName, "/home/boenzlip/orxonox/data/maps/santa_claus.pcx");
-        m->debug();
+      MD2Model* m = new MD2Model(fileName, "/home/boenzlip/orxonox/data/maps/santa_claus.pcx");
+      m->debug();
+      this->supportsLOD = false;
         //this->setModel((Model*)ResourceManager::getInstance()->load(fileName, MD2, RP_CAMPAIGN), 0);
-        this->setModel((Model*)m, 0);
-      }
+      this->setModel((Model*)m, 0);
+    }
   }
   else