Index: /branches/christmas_branche/src/lib/graphics/importer/md2Model.cc
===================================================================
--- /branches/christmas_branche/src/lib/graphics/importer/md2Model.cc	(revision 6174)
+++ /branches/christmas_branche/src/lib/graphics/importer/md2Model.cc	(revision 6175)
@@ -149,4 +149,6 @@
 
 
+static sVec3D verticesList[MD2_MAX_VERTICES]; /* performance: created only once in a lifetime */
+
 /**
   \brief sets the time in seconds passed since the last tick
@@ -160,5 +162,6 @@
     this->animate();
 
-   this->renderFrame();
+  this->processLighting();
+  this->interpolate(verticesList);
 }
 
@@ -169,14 +172,9 @@
  * FIXME
  */
-void MD2Model::draw()
-{
-
-
-
-  //   glPushMatrix();
-
-  //this->renderFrame();
-
-//   glPopMatrix();
+void MD2Model::draw() const
+{
+  glPushMatrix();
+  this->renderFrame();
+  glPopMatrix();
 }
 
@@ -185,7 +183,6 @@
   \brief this is an internal function to render this special frame selected by animate()
 */
-void MD2Model::renderFrame()
-{
-  static sVec3D verticesList[MD2_MAX_VERTICES]; /* performance: created only once in a lifetime */
+void MD2Model::renderFrame() const
+{
   int* pCommands = this->data->pGLCommands;
 
@@ -196,6 +193,4 @@
   glCullFace(GL_BACK);
 
-  this->processLighting();
-  this->interpolate(verticesList);
 
   this->data->material->select();
Index: /branches/christmas_branche/src/lib/graphics/importer/md2Model.h
===================================================================
--- /branches/christmas_branche/src/lib/graphics/importer/md2Model.h	(revision 6174)
+++ /branches/christmas_branche/src/lib/graphics/importer/md2Model.h	(revision 6175)
@@ -143,5 +143,5 @@
   virtual ~MD2Model();
 
-  virtual void draw();
+  virtual void draw() const;
 
   void setAnim(int type);
@@ -160,5 +160,5 @@
   void processLighting();
   void interpolate(sVec3D* verticesList);
-  void renderFrame();
+  void renderFrame() const ;
 
 
Index: /branches/christmas_branche/src/world_entities/creatures/md2_creature.cc
===================================================================
--- /branches/christmas_branche/src/world_entities/creatures/md2_creature.cc	(revision 6174)
+++ /branches/christmas_branche/src/world_entities/creatures/md2_creature.cc	(revision 6175)
@@ -241,8 +241,5 @@
     ((MD2Model*)this->models[0])->draw();
 
-  this->getWeaponManager()->draw();
-
-
-  //this->debug(0);
+  //this->getWeaponManager()->draw();
 }
 
@@ -260,38 +257,38 @@
 
 
-  // MD2Creature controlled movement
-  this->calculateVelocity(time);
-
-  Vector move = (velocity)*time;
-
-  //orient the velocity in the direction of the MD2Creature.
-  travelSpeed = velocity.len();
-  velocity += ((this->getAbsDirX())*travelSpeed-velocity)*airViscosity;
-  velocity = (velocity.getNormalized())*travelSpeed;
-
-  //orient the MD2Creature in direction of the mouse
-   rotQuat = Quaternion::quatSlerp( this->getAbsDir(),mouseDir,fabsf(time)*3);
-   if (this->getAbsDir().distance(rotQuat) > 0.001)
-    this->setAbsDir( rotQuat);
-   //this->setAbsDirSoft(mouseDir,5);
-
-  // this is the air friction (necessary for a smooth control)
-  if(velocity.len() != 0) velocity -= velocity*0.01;
-
-  //hoover effect
-  cycle += time;
-  this->shiftCoor(Vector(0,1,0)*cos(this->cycle*2.0)*0.02);
-
-  //readjust
- // if (this->getAbsDirZ().y > 0.1) this->shiftDir(Quaternion(time*0.3, Vector(1,0,0)));
-  //else if (this->getAbsDirZ().y < -0.1) this->shiftDir(Quaternion(-time*0.3, Vector(1,0,0)));
-
-  //SDL_WarpMouse(GraphicsEngine::getInstance()->getResolutionX()/2, GraphicsEngine::getInstance()->getResolutionY()/2);
-
-  this->shiftCoor (move);
-
-  this->getWeaponManager()->tick(time);
-  // weapon system manipulation
-  this->weaponAction();
+//   // MD2Creature controlled movement
+//   this->calculateVelocity(time);
+//
+//   Vector move = (velocity)*time;
+//
+//   //orient the velocity in the direction of the MD2Creature.
+//   travelSpeed = velocity.len();
+//   velocity += ((this->getAbsDirX())*travelSpeed-velocity)*airViscosity;
+//   velocity = (velocity.getNormalized())*travelSpeed;
+//
+//   //orient the MD2Creature in direction of the mouse
+//    rotQuat = Quaternion::quatSlerp( this->getAbsDir(),mouseDir,fabsf(time)*3);
+//    if (this->getAbsDir().distance(rotQuat) > 0.001)
+//     this->setAbsDir( rotQuat);
+//    //this->setAbsDirSoft(mouseDir,5);
+//
+//   // this is the air friction (necessary for a smooth control)
+//   if(velocity.len() != 0) velocity -= velocity*0.01;
+//
+//   //hoover effect
+//   cycle += time;
+//   this->shiftCoor(Vector(0,1,0)*cos(this->cycle*2.0)*0.02);
+//
+//   //readjust
+//  // if (this->getAbsDirZ().y > 0.1) this->shiftDir(Quaternion(time*0.3, Vector(1,0,0)));
+//   //else if (this->getAbsDirZ().y < -0.1) this->shiftDir(Quaternion(-time*0.3, Vector(1,0,0)));
+//
+//   //SDL_WarpMouse(GraphicsEngine::getInstance()->getResolutionX()/2, GraphicsEngine::getInstance()->getResolutionY()/2);
+//
+//   this->shiftCoor (move);
+//
+//   this->getWeaponManager()->tick(time);
+//   // weapon system manipulation
+//   this->weaponAction();
 }
 
Index: /branches/christmas_branche/src/world_entities/world_entity.cc
===================================================================
--- /branches/christmas_branche/src/world_entities/world_entity.cc	(revision 6174)
+++ /branches/christmas_branche/src/world_entities/world_entity.cc	(revision 6175)
@@ -136,7 +136,7 @@
     else if(strstr(fileName, ".md2"))
     {
-      PRINTF(0)("fetching MD2 file: %s\n", fileName);
+      PRINTF(4)("fetching MD2 file: %s\n", fileName);
 //         MD2Model* m = (MD2Model*)ResourceManager::getInstance()->load(fileName, MD2, RP_CAMPAIGN);
-      MD2Model* m = new MD2Model(fileName, "/home/boenzlip/orxonox/data/maps/santa_claus.pcx");
+      MD2Model* m = new MD2Model(fileName, "/home/boenzlip/orxonox/data/maps/santa_claus.png");
       m->debug();
       this->supportsLOD = false;